/*
** Generate operations list for login user
** Class: FrontPage
** Author: Yuping Zhu
** Date: 10-27-1999
** Modified: 01-20-2000 by Yuping Zhu
**    Action: Web intreface changed from ASC
** Modified: 12-30-2000 by Jake Kim
*/

package ascdb.users;

// import package oracle.html to generate HTML page
import oracle.html.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.sql.*;

import ascdb.conf;
import ascdb.users.UserValidation;

public class FrontPage extends HttpServlet {

   private static String purpose;
   private String id;
   private String Email;
   private conf dbconf;

   public void doPost(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
	// Output HTML page header
        res.setContentType("text/html");
        PrintWriter out = res.getWriter();
	//   id = req.getParameter("uid");
	dbconf = new conf(req);
	Email = dbconf.TMDEmail;
	UserValidation UserV = new UserValidation();

       	try {
	   //validate user
	    int tabRow = UserV.Validation(req);
	   if (tabRow == 0){
	       out.println("You are not current TMD user");
	       return;
	   }
	   else if (tabRow == 1) {
	       out.println("You need correct password to login!");
	       return;
	   }

	   id = UserV.UserId();
	   purpose = UserV.purpose;
	   // generate table to hold operations user can do
	   allOperations(out,tabRow);
	}
	catch (ClassNotFoundException e) {
	    out.println("Can not load the JDBC Driver!");
	}
	catch (SQLException e) {
	     out.println(e.getMessage());
	}
    }

    /*  private int Validation(HttpServletRequest req)
            throws ClassNotFoundException,SQLException
    {
	conf dbconf = new conf(req);
	Email = dbconf.TMDEmail;
	// load JDBC driver
	Class.forName(dbconf.JdbcDriver);
	// Connect to the DB
	Connection conn =
	    DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);

        // Create a Statement
	Statement stmt = conn.createStatement ();

	id = req.getParameter("uid");
	String passwd = req.getParameter("passwd");

	String queryStr = "select tmd_password,logged_in from addl_users where oracle_uid ='" + id + "'";

	ResultSet rset = stmt.executeQuery(queryStr);
	if (! rset.next())
	    return 0;
	else if(((rset.getString(2)).equals("N")) && ! passwd.equals(rset.getString(1)))
	    return 1;
	ResultSet role = stmt.executeQuery("select purpose from users where oracle_uid='" + id + "'");
	if (role.next()) {
	    purpose = role.getString(1);
	    // set user login
	    int count = stmt.executeUpdate("update addl_users set logged_in ='Y'");
	    if (purpose.equals("Student"))
	       return 6;
	    else if (purpose.equals("Instructor"))
		return 7;
	    else if (purpose.equals("Administrator"))
		return 10;
	    else return 6;
	}
	return 0;
    }

    */
    private void allOperations(PrintWriter out, int num)
    {

	// Create the HTML Page head
	HtmlHead hd = new HtmlHead("TMD " + purpose + " Page");

	// Create an HtmlBody Object
        HtmlBody bd = new HtmlBody();

        //bd.setBackgroundColor(Color.white);
        bd.setBackgroundColor("#f2fff2");
	 // Creates an HtmlPage object using hd and bd
        HtmlPage hp = new HtmlPage(hd, bd);

	bd
	    .addItem(SimpleItem.Paragraph)
	    .addItem(new SimpleItem("Welcome to the TMD").setCenter().setBold().setFontSize(+6).setFontColor(Color.red))
            .addItem(SimpleItem.Paragraph)
            .addItem(SimpleItem.HorizontalRule)
            .addItem(SimpleItem.Paragraph);

	// Create table to hold all these links
	DynamicTable tab = new DynamicTable(2);
	tab.setBackgroundColor ("#AAFFFF");
	tab.setBorder(0);
	tab.setCellSpacing(3);
	tab.setCellPadding(5);
	TableRow[] rows = new TableRow[num];	
        for (int i=0; i<num; i++)
	    rows[i] = new TableRow();
       	rows[0]
	    .addCell(new TableDataCell(new Link("ascdb.classes.ClassList?op=1&uid=" + id,new SimpleItem("View Training Schedule").setBold())))
	    .addCell(new TableDataCell(new Link("ascdb.classes.ClassList?op=2&uid=" + id, new SimpleItem("Register for a class").setBold())));
	rows[1]
	    .addCell(new TableDataCell(new Link("ascdb.classes.ClassList?op=8&uid=" + id, new SimpleItem("Evaluation Form for Completed Class").setBold())))
	    .addCell(new TableDataCell(new Link("ascdb.classes.ClassList?op=9&uid=" + id, new SimpleItem("Change your Registration").setBold())));
	rows[2]
	    .addCell(new TableDataCell(new Link("ascdb.classes.ClassList?op=3&uid=" + id, new SimpleItem("Class List").setBold())))
	    .addCell(new TableDataCell(new Link("ascdb.users.ModifyUser?uid=" + id,new SimpleItem("Change/Update User Information").setBold())));
	rows[3]
	    //.addCell(new TableDataCell("<A HREF=\"ascdb.users.RemoveFromTMD?uid=" + id + "\" onClick=return (RemoveConfirm(this))> ok </A>"))
	    .addCell(new TableDataCell(new Link("ascdb.users.RemoveFromTMD?uid=" + id, new SimpleItem("Request Removal from TMD").setBold())))
	    .addCell(new TableDataCell(new Link("ascdb.users.UserLogout?uid=" + id, new SimpleItem("Logout").setBold())));
	if (purpose.equals("Instructor") || purpose.equals("Administrator")) 
	    rows[4]
		.addCell(new TableDataCell(new Link("ascdb.courses.CourseList?uid=" + id + "&op=9", new SimpleItem("Class Information Form").setBold())))
		
		//.addCell(new TableDataCell(new Link("ascdb.classes.ClassList?op=3&uid=" + id, new SimpleItem("List other registrants for a class").setBold())));
		.addCell(new TableDataCell(new Link("ascdb.classes.ClassList?op=5&uid=" + id, new SimpleItem("Change/Update Posted Class").setBold())));
		 
	if (purpose.equals("Administrator")) {
	    rows[5]
		.addCell(new TableDataCell(new Link("ascdb.classes.ClassList?op=4&uid=" + id,new SimpleItem("Post a Class").setBold())))
		.addCell(new TableDataCell(new Link("ascdb.courses.CreateCatalog?uid=" + id, new SimpleItem("Append the Catalog").setBold())));
	    rows[6]
		.addCell(new TableDataCell(new Link("ascdb.admin.VerifyUser?op=1&uid=" + id + "&type=0", new SimpleItem("Verify New User").setBold())))
	    //		.addCell(new TableDataCell(new Link("ascdb.admin.VerifyUser?op=2&uid=" + id + "&type=0", new SimpleItem("Verify Instructor").setBold())))
		.addCell(new TableDataCell(new Link("ascdb.admin.VerifyClass?op=1&uid=" + id, new SimpleItem("Verify Class/Course").setBold())));
	}
       for (int i=0; i < num; i++)
	   tab.addRow(rows[i]);
       bd.addItem(tab.setCenter());
       bd
          .addItem(SimpleItem.Paragraph)
	  .addItem(new Image(dbconf.ImageBase + "wavy.gif").setCenter())
	  .addItem(new SimpleItem("<center><address>For questions, contact "))
	  .addItem(new Link("mailto:" + dbconf.AdminEmail, dbconf.AdminName))
	  .addItem(new SimpleItem(" or call toll-free 1-888-MSRC-ASC (1-888-677-2272)."))
	  .addItem(new SimpleItem(" </address></center>"));
       out.println(hp);
    }
}
